<?php
/**
 * @author    Climaxweb <climaxwebmaxell@gmail.com>
 * @link      https://www.climaxweb.net/maxbot/
 * @copyright 2019 Climaxweb
 */


if(!defined('ABSPATH')) exit();

/**
 * Create new block for the newly created topic, this is 
 * the first block to be created once the topic is added.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_return_default_cp')){
	
  function smwpcb_return_default_cp(){

    $randomTopic = rand(100000000000000000, 1000000000000000000);
    return '
      <div class="tree" style="width:1000px;">
        <input type="hidden" value="'.$randomTopic.'" id="parentIDsInput">
        <ul class="executableul">
            <li class="executable">
                <div class="panelcb">
                    <div class="infom infom11" element-id="'.$randomTopic.'" parent-element="11">
                        <div class="verticalTab" class="resp-vtabs" style="display: block; width: 100%; margin: 0px;">
                            <ul class="resp-tabs-list">
                                <li class="resp-tab-item"><span><img src="'. SMWPCB_PLUGIN_URL_DIR . '/admin/images/paper.png" alt=""/> </span></li>
                                <li class="resp-tab-item"><span><img src="'. SMWPCB_PLUGIN_URL_DIR . '/admin/images/target.png" alt=""/> </span></li>
                                <li class="resp-tab-item"><span><img src="'. SMWPCB_PLUGIN_URL_DIR . '/admin/images/list.png" alt=""/> </span></li>
                                <li class="resp-tab-item smwpcb_mortarboard"><span><img src="'. SMWPCB_PLUGIN_URL_DIR . '/admin/images/mortarboard.png" alt=""/> </span></li>
                            </ul>
                            <div class="resp-tabs-container">
                                <span class="resp-arrow"></span><i class="icon_2"></i>
                                <div class="new_posts resp-tab-content">
                                    <div class="contact-form1">
                                        <h2>Bot Messages</h2>
                                        <div class="alert alert-danger smwpcb_disply_errors" role="alert" style="display:none;"></div>
                                        <div class="form-group">
                                            <label>Message bubble</label>
                                            <div class="responsescontainer">
                                                <textarea id="botresponse" class="botresponse form-control smwpcb_bubble_default" placeholder="Message bubble" rows="3"></textarea>
                                            </div>
                                            <img id="addresponse" title="Add Message Bubble" class="smwpch_add_product" src="'. SMWPCB_PLUGIN_URL_DIR . '/admin/images/add-message.png">
                                            <span class="help-block">Set the messages that the bot will send the user on this case, click on add button to add more message bubbles.</span>
                                        </div>
                                    </div>
                                </div>
                                <span class="resp-arrow"></span><i class="icon_3"></i>
                                <div class="new_posts resp-tab-content">
                                    <div class="contact-form1">
                                        <h2>Next Block</h2>
                                        <div class="alert alert-danger smwpcb_disply_errors" role="alert" style="display:none;"></div>
                                        <input type="hidden" value="1" id="resort_value">
                                        <div class="smwpcb_margin_bottom radio">
                                            <label>
                                                <span class="smwpcb_switch_radio">
                                                  <input id="usedefautrescheck" type="radio" name="resort_'.$randomTopic.'" value="1" checked>
                                                  <i class="far fa-check-circle smwpcb_switch_radio_checked"></i>
                                                  <i class="far fa-circle smwpcb_switch_radio_unchecked"></i>
                                                </span> Use keywords to target the next block for the conversation to flow.
                                            </label>
                                        </div>
                                        <div class="smwpcb_margin_left dresToggle">
                                            <div class="form-group">
                                                <label>Default message</label>
                                                <textarea id="defaultresponse" class="smwpcb_bubble_default form-control" placeholder="Message bubble" rows="3"></textarea>
                                                <span class="help-block">Use this message bubble to entice users to write text having keywords from the already available block cases.</span>
                                            </div>
                                            <div class="form-group">
                                                <label>Repeat Tolerance</label>
                                                <input type="number" value="1" min="1" max="100" id="repeatTolerance" class="form-control borderbottombluecolorred smwpch_number_fields" placeholder="Tolerance">
                                                <span class="help-block">Write how many times you want your bot to repeat this message until it resorts to the fixed quick reply buttons.</span>
                                            </div>
                                            <div class="checkbox">
                                                <label>
                                                    <span class="smwpcb_switch_checkbox">
                                                      <input id="storeusrmessage" type="checkbox" value="1">
                                                      <i class="fas fa-check-square smwpcb_switch_checked"></i>
                                                      <i class="fas fa-square smwpcb_switch_unchecked"></i>
                                                    </span> Store the user reply of this block to the database
                                                </label>
                                            </div>
                                            <div class="messagevarToggle" style="display:none;">
                                                <div class="form-group">
                                                    <label>Stored as</label>
                                                    <input type="text" id="storedmsguser" class="form-control borderbottombluecolorred" placeholder="variable" autocomplete="off" style="width:150px;">
                                                    <span class="help-block">Enter the variable that you want the reply to be stored as.</span>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="smwpcb_margin_bottom radio">
                                            <label>
                                                <span class="smwpcb_switch_radio">
                                                  <input id="restorevarscheck" type="radio" name="resort_'.$randomTopic.'" value="1">
                                                  <i class="far fa-check-circle smwpcb_switch_radio_checked"></i>
                                                  <i class="far fa-circle smwpcb_switch_radio_unchecked"></i>
                                                </span> Restore the user input of this block into one of the available data column
                                            </label>
                                        </div>
                                        <div class="smwpcb_margin_left togglePanel" style="display:none">
                                            <div class="panel panel-default">
                                                <div class="panel-heading" style="text-align: center;">Available Columns</div>
                                                <table class="table">
                                                    <thead>
                                                        <tr>
                                                            <th>Check</th>
                                                            <th>Column Name</th>
                                                            <th>Variable Name</th>
                                                        </tr>
                                                    </thead>
                                                    <tbody>
                                                        '.smwpcb_display_data_columns($randomTopic,0).'
                                                    </tbody>
                                                </table>
                                            </div>
                                            <span class="help-block">These data columns can be manually set in the previous options, you can use the chosen @variable-name on the next message bubbles.</span>
                                        </div>
                                        <div class="smwpcb_margin_bottom radio">
                                            <label>
                                                <span class="smwpcb_switch_radio">
                                                  <input id="usefaqoptionscheck" type="radio" name="resort_'.$randomTopic.'" value="1">
                                                  <i class="far fa-check-circle smwpcb_switch_radio_checked"></i>
                                                  <i class="far fa-circle smwpcb_switch_radio_unchecked"></i>
                                                </span> Force the user to choose from the available fixed quick replies options
                                            </label>
                                        </div>
                                        <div class="smwpcb_margin_left togglefaq" style="display:none">
                                            <div class="checkbox" style="margin-top: -6px;">
                                                <label>
                                                    <span class="smwpcb_switch_checkbox">
                                                      <input id="storeusrmessagefaq" type="checkbox" value="1">
                                                      <i class="fas fa-check-square smwpcb_switch_checked"></i>
                                                      <i class="fas fa-square smwpcb_switch_unchecked"></i>
                                                    </span> Store the user choice this block to the database
                                                </label>
                                            </div>
                                            <div class="messagefaqToggle" style="display:none;">
                                                <div class="form-group">
                                                    <label>Stored as</label>
                                                    <input type="text" id="storedmsguserfaq" class="form-control borderbottombluecolorred" placeholder="variable" autocomplete="off" style="width:150px;">
                                                    <span class="help-block">Enter the variable that you want the choice to be stored as.</span>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <span class="resp-arrow"></span><i class="icon_4"></i>
                                <div class="new_posts resp-tab-content">
                                    <div class="contact-form1">
                                        <h2>Bot Tasks</h2>
                                        <div class="alert alert-danger smwpcb_disply_errors" role="alert" style="display:none;"></div>
                                        <div class="checkbox smwpcb_margin_bottom">
                                            <label>
                                                <span class="smwpcb_switch_checkbox">
                                                  <input id="displayprod" type="checkbox" value="1">
                                                  <i class="fas fa-check-square smwpcb_switch_checked"></i>
                                                  <i class="fas fa-square smwpcb_switch_unchecked"></i>
                                                </span> Link on the bot messages of this block a descriptive card of a multiple products, articles, or links etc.
                                            </label>
                                        </div>
                                        <div class="toggleProduct smwpcb_margin_left" style="display:none">
                                            <div class="addPrdiv">
                                                <div class="prodiv">
                                                    <div class="form-group">
                                                        <label>Image Url</label>
                                                        <input type="url" class="form-control borderbottombluecolorred imageurl" placeholder="http://" style="width: 90%;" autocomplete="off">
                                                    </div>
                                                    <div class="form-group">
                                                        <label>Link</label>
                                                        <input type="url" class="form-control borderbottombluecolorred linktocap" placeholder="http://" style="width: 90%;" autocomplete="off">
                                                    </div>
                                                    <div class="form-group">
                                                        <label>Title</label>
                                                        <input type="text" class="form-control borderbottombluecolorred titlecap" placeholder="please enter a title" style="width: 90%;" autocomplete="off">
                                                    </div>
                                                    <div class="form-group">
                                                        <label>Description</label>
                                                        <textarea rows="3" class="form-control borderbottombluecolorred descriptioncap" placeholder="please enter a description" style="width: 90%;"></textarea>
                                                    </div>
                                                    <div class="form-group">
                                                        <label>Text button</label>
                                                        <input type="text" class="form-control borderbottombluecolorred caption" placeholder="please enter a text button" style="width: 90%;" autocomplete="off">
                                                    </div>
                                                </div>
                                            </div>
                                            <img id="addproduct" title="add card" class="smwpcb_add_product" src="'. SMWPCB_PLUGIN_URL_DIR . '/admin/images/add-message.png">
                                        </div>

                                        <div class="checkbox smwpcb_margin_bottom">
                                            <label>
                                                <span class="smwpcb_switch_checkbox">
                                                <input type="checkbox" id="imageCheck" value="1">
                                                <i class="fas fa-check-square smwpcb_switch_checked"></i>
                                                <i class="fas fa-square smwpcb_switch_unchecked"></i>
                                                </span> Link on the bot messages of this block an image(s) or gif(s).
                                            </label>
                                        </div>

                                        <div class="toggleImage smwpcb_margin_left" style="display:none">
                                            <div class="addimagediv">
                                                <div class="imagediv">
                                                    <div class="form-group">
                                                        <label>Image Url</label>
                                                        <input type="url" class="form-control borderbottombluecolorred imagedisplayurl" placeholder="https://" style="width:90%" autocomplete="off">
                                                    </div>
                                                </div>
                                            </div>
                                            <img id="addimage" title="add image" class="smwpcb_add_product" src="'. SMWPCB_PLUGIN_URL_DIR . '/admin/images/add-message.png">
                                        </div>

                                        <div class="checkbox smwpcb_margin_bottom">
                                            <label>
                                                <span class="smwpcb_switch_checkbox">
                                                <input type="checkbox" id="videoCheck" value="1">
                                                <i class="fas fa-check-square smwpcb_switch_checked"></i>
                                                <i class="fas fa-square smwpcb_switch_unchecked"></i>
                                                </span> Link on the bot messages of this block an embeded youtube video(s).
                                            </label>
                                        </div>
                                        <div class="toggleVideo smwpcb_margin_left" style="display:none">
                                            <div class="addvideodiv">
                                                <div class="videodiv">
                                                    <div class="form-group">
                                                        <label>Video Url</label>
                                                        <input type="url" class="form-control borderbottombluecolorred videodisplayurl" placeholder="https://" style="width:90%" autocomplete="off">
                                                    </div>
                                                </div>
                                            </div>
                                            <img id="addvideo" title="add video" class="smwpcb_add_product" src="'. SMWPCB_PLUGIN_URL_DIR . '/admin/images/add-message.png">
                                        </div>
                                    </div>
                                </div>
                                <span class="resp-arrow"></span><i class="icon_4"></i>
                                <div class="new_posts resp-tab-content">
                                    <div class="contact-form1">
                                        <h2>Train Your Bot</h2>
                                        <h5>In this panel you may find users responses that didn\'t match any of the available children blocks</h5>
                                        <div id="unsetedTriggers">
                                            <div class="alert alert-info alert-dismissible" role="alert">
                                                <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                                                There is no unsolved users response yet on this block.
                                            </div>
                                        </div>

                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="clearfix"> </div>
                    <div class="chatbotTools">
                        <ul class="resp-tabs-list" style="position: absolute; left:71px">
                            <li class="resp-tab-item cbpanelzoom" style="width:106px;">
                                <div style="width:100%;height:25px"><span><img src="'. SMWPCB_PLUGIN_URL_DIR . 'admin/images/zoom-in.png" alt=""/> </span></div>
                            </li>
                            <li class="resp-tab-item options_bellow reduce_panel" style="width:106px;">
                                <div style="width:100%;height:25px"><span><img src="'. SMWPCB_PLUGIN_URL_DIR . 'admin/images/caret-down.png" alt=""/> </span></div>
                            </li>
                            <li class="resp-tab-item options_bellow add_children_button" style="width:106px;" element-id="'.$randomTopic.'">
                                <div style="width:100%;height:25px"><span><img src="'. SMWPCB_PLUGIN_URL_DIR . 'admin/images/plus.png" alt=""/> </span></div>
                            </li>
                        </ul>
                    </div>
                </div>
            </li>
        </ul>
      </div>
      ';

  }

}

/**
 * Construct the default settings after the plugin
 * is initiated.
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_define_settings_default')){

    function smwpcb_define_settings_default() {

      $smwpcb_general_settings_default = array(
        'smwpcb_chatbots_conversation_starter' => '0',
        'smwpcb_chatbots_timeout_autogreeting' => '1',
        'smwpcb_chatbots_timeout_responsing' => '1',
        'smwpcb_chatbots_timeout_writing' => '1',
        'smwpcb_delete_maxbot_data' => '0'
      );
      $smwpcb_data_tables_default = array();
      $smwpcb_default_ui_settings = smwpcb_contruct_ui_settings(array());
      if (!get_option('smwpcb_chatbots_general_settings')) {
        add_option('smwpcb_chatbots_general_settings', $smwpcb_general_settings_default, array(), 'no');
      }
      if (!get_option('smwpcb_data_tables_settings')) {
        add_option('smwpcb_data_tables_settings', $smwpcb_data_tables_default, array(), 'no');
      }
      if (!get_option('smwpcb_wp_chatbot_topics_settings')) {
        add_option('smwpcb_wp_chatbot_topics_settings', array(), '', 'no');
      }
      if (!get_option('smwpcb_unsetted_response_triggers')) {
        add_option('smwpcb_unsetted_response_triggers', array(), '', 'no');
      }
      if (!get_option('smwpcb_wp_chatbot_projects_settings')) {
        add_option('smwpcb_wp_chatbot_projects_settings', array(), '', 'no');
      }
      if (!get_option('smwpcb_wp_chatbot_agents_settings')) {
        add_option('smwpcb_wp_chatbot_agents_settings', array(), '', 'no');
      }
      if (!get_option('smwpcb_cb_ui_custom_settings')) {
        add_option('smwpcb_cb_ui_custom_settings', $smwpcb_default_ui_settings, '', 'no');
      }
      if (!get_option('smwpcb_custom_design_version')) {
        add_option('smwpcb_custom_design_version', 1, '', 'no');
      }
      if (!get_option('smwpcb_wp_chatbot_code_licence_settings')) {
        add_option('smwpcb_wp_chatbot_code_licence_settings', array('smwpcb_wp_code_licence'=>array('smwpcb_code_licence0'=>'')), '', 'no');
      }
      if (!get_option('smwpcb_maxbot_additional_settings')) {
        add_option('smwpcb_maxbot_additional_settings', array('smwpcb_user_rating'=> ''), '', 'no');
      }
      if (!get_option('smwpcb_plugin_rating_options')) {
        add_option('smwpcb_plugin_rating_options', array(1, '', ''), '', 'no');
    }

    }

}

/**
 * Create these default settings and create dbs
 * on the init_admin hook
 * @since: 1.0.0
 **/
if(!function_exists('smwpcb_init_admin_options')){

    function smwpcb_init_admin_options() {

        if (isset($_REQUEST['page']) ) {
            smwpcb_define_settings_default();
            smwpcb_create_db_dialog_flow_options();
        }

    }

}



?>