"use strict";

jQuery(function($) {
 
    $(document).ready(function() {

        $(".smwpcb_widget_content").prependTo("body");

        var dataArr = []; 
        var openedPrime = false;
        smwpcb_hide_widget_trigger();
        smwpcb_initiate_bot = new RiveScript({
            utf8: true
        });
        smwpcb_initiate_bot.unicodePunctuation = new RegExp();

        // this must change!
        smwpcb_initiate_bot.loadFile([
            smwpcb_main_script_link.brain_path + "/functions.rive?v=" + (1000000000000000000 * Math.random()),
            smwpcb_main_script_link.brain_path + "/allTopics.rive?v=" + (1000000000000000000 * Math.random())
        ]).then(smwpcb_loading_done).catch(smwpcb_loading_error);


        function smwpcb_loading_done() {
            if ($(".smwpcb_widget_chat").length != 0) {
                smwpcb_initiate_bot.sortReplies();
                smwpcb_invoke_topic_trigger();

            }
        }

        // It's good to catch errors too!
        function smwpcb_loading_error(error, filename, lineno) {
            console.log("Error when loading files: " + error);
        }


        $(window).on("resize", function() {
            if (window.matchMedia('(max-width: 767px)').matches) {
                if ($('.smwpcb_chat_layout').hasClass('smwpcb_is_visible')) {
                    $('.smwpcb_widget_chat_convers').addClass('smwpcb_is_hidden_resize');
                    $('.smwpcb_widget_chat_convers').removeClass('smwpcb_is_visible_resize');
                }
            } else {
                if ($('.smwpcb_widget_chat_convers').hasClass('smwpcb_is_hidden_resize')) {
                    $('.smwpcb_widget_chat_convers').removeClass('smwpcb_is_hidden_resize');
                }
                if ($('.smwpcb_chat_layout').hasClass('smwpcb_is_visible')) {
                    $('.smwpcb_widget_chat_convers').addClass('smwpcb_is_visible_resize');
                }
            }
        });



        $('body').on('click', '#smwpcb_widget_trigger,.smwpcb_back', function() {
            smwpcb_toggle_widget_trigger();
            if (!openedPrime) {
                openedPrime = true;
                var topicId = $('#smwpcb_topic_id_input').val();
                setTimeout(function() {
                    smwpcb_new_users_message('topic' + topicId, true);
                }, 2500);

            }
            if (($(window).width() < 768) && ($(this).attr("id") == 'smwpcb_widget_trigger')) {
                $(this).css('display', 'none');
            } else if ($(window).width() < 768) {
                $('#smwpcb_widget_trigger').css('display', 'block');
            }

            if ($('.smwpcb_chat_input_field').hasClass('smwpcb-show-panel') && !$('.smwpcb_widget_chat_convers').hasClass('smwpcb_card_red_notification')) {
                $('.smwpcb_chat_input_field').addClass('smwpcb-hide-panel');
                $('.smwpcb_chat_input_field').removeClass('smwpcb-show-panel');
            } else {
                $('.smwpcb_chat_input_field').removeClass('smwpcb-hide-panel');
                $('.smwpcb_chat_input_field').addClass('smwpcb-show-panel');
            }

            if ($('.smwpcb_chat_layout').hasClass('smwpcb-show-panel')) {
                $('.smwpcb_chat_layout').addClass('smwpcb-hide-panel');
                $('.smwpcb_chat_layout').removeClass('smwpcb-show-panel');
            } else {
                $('.smwpcb_chat_layout').removeClass('smwpcb-hide-panel');
                $('.smwpcb_chat_layout').addClass('smwpcb-show-panel');
            }

            if ($('.smwpcb_widget_trigger').hasClass('zmdi-notifications-active') && $('.smwpcb_widget_chat_convers').hasClass('smwpcb_card_red_notification')) {
                $('.smwpcb_widget_trigger').addClass('zmdi-close');
                $('.smwpcb_widget_trigger').removeClass('zmdi-comment-outline');
                $('.smwpcb_widget_trigger').removeClass('zmdi-notifications-active');
                $('.smwpcb_widget_chat_convers').removeClass('smwpcb_card_red_notification');
                //$(".smwpcb_chat_conversation_flow").css("padding-bottom", (parseInt($(".smwpcb_chat_conversation_flow").css("padding-bottom").substring(0, $(".smwpcb_chat_conversation_flow").css("padding-bottom").length - 1)) + $(".smwpcb_chat_input_field").height()));
                $(".smwpcb_chat_conversation_flow").css("border-bottom", (parseInt($(".smwpcb_chat_conversation_flow").css("border-bottom").substring(0, $(".smwpcb_chat_conversation_flow").css("border-bottom").length - 17)+ $(".smwpcb_chat_input_field").height())+"px solid transparent") );
                $(".smwpcb_chat_conversation_msgs").stop().animate({
                    scrollTop: $(".smwpcb_chat_conversation_msgs")[0].scrollHeight
                }, 1000);
            }

        });

        $('body').on('click', '#smwpcb_input_send', function() {
            if (smwpcb_allow_new_message[0] == true) {
                if (smwpcb_restore_helper['status']) {
                    var data = {
                        'action': 'smwpcb_add_users_response_action',
                        'addedValue': [smwpcb_sanitize_text_field(smwpcb_restore_helper['datahelper']), smwpcb_sanitize_text_field($('#smwpcb_send_message_chat').val()), smwpcb_sanitize_text_field($('.smwpcb_widget_chatbot').attr('uniqueID'))]
                    };
                    jQuery.post(smwpcb_main_script_link.ajax_url, data);
                    smwpcb_restore_helper = {
                        'status': false,
                        'datahelper': ''
                    };
                }
                smwpcb_outputmsg_count = 0;

                smwpcb_new_users_message($('#smwpcb_send_message_chat').val(), false);
                $('#smwpcb_send_message_chat').val('');
            }
        });

        $('body').on('keydown', '#smwpcb_send_message_chat', function(e) {
            if (e.which == 13 && !e.shiftKey) {
                if (smwpcb_allow_new_message[0] == true) {
                    var chatval = $('#smwpcb_send_message_chat').val();
                    $('#smwpcb_send_message_chat').val('');
                    if (smwpcb_restore_helper['status']) {
                        var data = {
                            'action': 'smwpcb_add_users_response_action',
                            'addedValue': [smwpcb_sanitize_text_field(smwpcb_restore_helper['datahelper']), smwpcb_sanitize_text_field(chatval), smwpcb_sanitize_text_field($('.smwpcb_widget_chatbot').attr('uniqueID'))]
                        };
                        jQuery.post(smwpcb_main_script_link.ajax_url, data);
                        smwpcb_restore_helper = {
                            'status': false,
                            'datahelper': ''
                        };
                    }
                    smwpcb_outputmsg_count = 0;
                    smwpcb_new_users_message(chatval, false);
                }
                e.preventDefault();
                return false;
            }

        });

        $('body').on('click', '.smwpcb_chat_input', function(e) {
            $(".smwpcb_chat_conversation_msgs").stop().animate({
                scrollTop: $(".smwpcb_chat_conversation_msgs")[0].scrollHeight
            }, 1000);
        });

        $('body').on('click', ".smwpcb_quick_replies li a", function() {
            if (smwpcb_restore_helper['status']) {
                var data = {
                    'action': 'smwpcb_add_users_response_action',
                    'addedValue': [smwpcb_sanitize_text_field(smwpcb_restore_helper['datahelper']), smwpcb_sanitize_text_field($(this).text()), smwpcb_sanitize_text_field($('.smwpcb_widget_chatbot').attr('uniqueID'))]
                };
                jQuery.post(smwpcb_main_script_link.ajax_url, data);
                smwpcb_restore_helper = {
                    'status': false,
                    'datahelper': ''
                };
            }

            if ($(window).width() < 768) {
                $(".smwpcb_chat_conversation_flow").css("border-bottom", "125px solid transparent");
            } else {
                $(".smwpcb_chat_conversation_flow").css("border-bottom", "50px solid transparent");
            }

            $('.smwpcb_chat_input_field').replaceWith(`<div class="smwpcb_chat_input_field smwpcb_chat_input_field_alt smwpcb-show-panel">
                <a style="` + smwpcb_reset_anchortag1 + `" id="smwpcb_input_send" class="smwpcb_widget_chat_convers smwpcb_is_visible"><i class="zmdi zmdi-mail-send"></i></a>
                <textarea style="` + smwpcb_reset_textarea + `" id="smwpcb_send_message_chat" placeholder="Send a message" class="smwpcb_chat_input"></textarea>
              </div>`);

            smwpcb_allow_new_message[2] = true;
            smwpcb_outputmsg_count = 0;
            smwpcb_new_users_message($(this).text(), false);
        });

        var imageLoaded = function() {
            setTimeout(function() {
                $('.smwpcb_loadings').css('display', 'none');
                $('.smwpcb_image_chat').css('display', 'block');
            }, 1000);
        }

        $('body').on('DOMNodeInserted', '.smwpcb_message_unit_agent', function() {
            if ($(this).find('.smwpcb_diplay_photo').length) {
                var tmpImg = new Image();
                tmpImg.onload = (function(elemnt) {
                    setTimeout(function() {
                        elemnt.find('.smwpcb_loadings').css('display', 'none');
                        elemnt.find('.smwpcb_image_chat').css('display', 'block');
                    }, 2000);
                })($(this));
                tmpImg.src = $(this).find('.smwpcb_image_chat').attr('src');
            }
        });

        function smwpcb_new_users_message(message, newMsg) {
            if ($(".smwpcb_widget_chat").length != 0) {
                if ($.trim(message) != '') {
                    smwpcb_user_responses.push(message);
                    smwpcb_allow_new_message[0] = false;
                    var audio = new Audio(smwpcb_main_script_link.audio_path + "/" + smwpcb_main_script_link.smwpcb_message_sound);
                    
                    var botMessage = '';
                    var messageTriped = message.replace(/[.,\/#!@§\[\]$%"?\^&\£<>*;:{}=\-_`~()]/g, " ").replace(/\s{2,}/g, " ");
                    smwpcb_initiate_bot.reply("local-user", messageTriped).then(function(reply) {
                        botMessage = reply;
                        smwpcb_bot_responses.push(reply);
                        if (!newMsg) {
                            $('<span class="smwpcb_message_unit smwpcb_message_unit_customer">' +smwpcb_escape_html(message)+ '</span>').appendTo('.smwpcb_chat_conversation_msgs');
                            $(".smwpcb_chat_conversation_msgs").stop().animate({
                                scrollTop: $(".smwpcb_chat_conversation_msgs")[0].scrollHeight
                            }, 600);

                        }
                        if (smwpcb_allow_new_message[2] == true) {
                            setTimeout(function() {
                                $(`<span class="smwpcb_message_unit smwpcb_message_unit_agent smwpcb_wave_animation">
                                      <div class="smwpcb_chat_avatar">
                                        <img src="` + smwpcb_escape_html($("#smwpcb_agent_photo").val()) + `"/>
                                      </div>
                                      <span class="smwpcb_writing_dot"></span>
                                      <span class="smwpcb_writing_dot"></span>
                                      <span class="smwpcb_writing_dot"></span>
                                   </span>`).appendTo('.smwpcb_chat_conversation_msgs');
                                $(".smwpcb_chat_conversation_msgs").stop().animate({
                                    scrollTop: $(".smwpcb_chat_conversation_msgs")[0].scrollHeight
                                }, 600);
                            }, 1000 * smwpcb_chatbots_general_settings['smwpcb_chatbots_timeout_responsing']);

                            setTimeout(function() {
                                var style = "";
                                if (botMessage.indexOf('<div class="smwpcb_outer_body_card"') >= 0) {
                                    style = "style='max-width:80% !important;text-align: center;'";
                                }
                                $('.smwpcb_chat_conversation_msgs').find('span.smwpcb_wave_animation').remove();
                                $(`<span class="smwpcb_message_unit smwpcb_message_unit_agent" ` + style + `>
                                    <div class="smwpcb_chat_avatar">
                                      <img src="` + smwpcb_escape_html($("#smwpcb_agent_photo").val()) + `"/>
                                      </div>` + botMessage + `</span>
                                    `).appendTo('.smwpcb_chat_conversation_msgs');
                                $(".smwpcb_chat_conversation_msgs").stop().animate({
                                    scrollTop: $(".smwpcb_chat_conversation_msgs")[0].scrollHeight
                                }, 1000);

                                if (!newMsg || smwpcb_chatbots_general_settings['smwpcb_chatbots_conversation_starter'] == '0') {
                                    audio.play();
                                }
                                if ($('.smwpcb_widget_trigger').hasClass('zmdi-comment-outline')) {
                                    $('.smwpcb_widget_trigger').removeClass('zmdi-comment-outline');
                                    $('.smwpcb_widget_trigger').addClass('zmdi-notifications-active');
                                    $('.smwpcb_widget_chat_convers').addClass('smwpcb_card_red_notification');
                                }
                                if (smwpcb_allow_new_message[1] == false && smwpcb_allow_new_message[3] == false) {
                                    smwpcb_allow_new_message[0] = true;
                                }
                            }, (1000 * smwpcb_chatbots_general_settings['smwpcb_chatbots_timeout_responsing'] + 1000 * smwpcb_chatbots_general_settings['smwpcb_chatbots_timeout_writing']));
                        }

                    });

                }
            }
        }

        $('body').on('click', '.smwpcb_talk_agent', function() {
            $(this).css('display', 'none');
            var topicId = $('#smwpcb_topic_id_input').val();
            smwpcb_new_users_message('topic' + topicId, true);
            openedPrime = true;
        });

        function smwpcb_get_url_parameter(sParam) {
            var sPageURL = window.location.search.substring(1),
                sURLVariables = sPageURL.split('&'),
                sParameterName,
                i;

            for (i = 0; i < sURLVariables.length; i++) {
                sParameterName = sURLVariables[i].split('=');

                if (sParameterName[0] === sParam) {
                    return sParameterName[1] === undefined ? true : decodeURIComponent(sParameterName[1]);
                }
            }
        }

        function smwpcb_invoke_topic_trigger() {
            if (smwpcb_chatbots_general_settings['smwpcb_chatbots_conversation_starter'] == '1') {
                openedPrime = true;
                var topicId = $('#smwpcb_topic_id_input').val();
                setTimeout(function() {
                    smwpcb_add_widget_trigger();
                    smwpcb_new_users_message('topic' + topicId, true);
                }, 1000 * smwpcb_chatbots_general_settings['smwpcb_chatbots_timeout_autogreeting']);

            }

        }

        function smwpcb_toggle_widget_trigger() {
            if (!$('.smwpcb_static_chat').length) {
                $('.smwpcb_widget_trigger').toggleClass('zmdi-comment-outline');
                $('.smwpcb_widget_trigger').toggleClass('zmdi-close');
                $('.smwpcb_widget_trigger').toggleClass('smwpcb_is_active');
                $('.smwpcb_widget_trigger').toggleClass('smwpcb_is_visible');
                $('#smwpcb_widget_trigger').toggleClass('smwpcb_is_float');
                $('.smwpcb_chat_layout').toggleClass('smwpcb_is_visible');
                $('.smwpcb_widget_chat_convers').toggleClass('smwpcb_is_visible');
                $('.smwpcb_widget_chat_convers').removeClass('smwpcb_is_hidden_resize');
                if ($(window).width() < 768) {
                    $('.smwpcb_widget_chat_convers').removeClass('smwpcb_is_visible_resize');
                }

            }

        }

        function smwpcb_add_widget_trigger() {
            if (!$('.smwpcb_static_chat').length) {
                $('.smwpcb_widget_trigger').removeClass('zmdi-comment-outline');
                $('.smwpcb_widget_trigger').addClass('zmdi-close');
                $('.smwpcb_widget_trigger').addClass('smwpcb_is_active');
                $('.smwpcb_widget_trigger').addClass('smwpcb_is_visible');
                $('#smwpcb_widget_trigger').addClass('smwpcb_is_float');
                $('.smwpcb_chat_layout').addClass('smwpcb_is_visible');
                $('.smwpcb_widget_chat_convers').addClass('smwpcb_is_visible');
                $('.smwpcb_chat_layout').addClass('smwpcb-show-panel');
                $('.smwpcb_chat_layout').removeClass('smwpcb-hide-panel');
                $('.smwpcb_chat_input_field').addClass('smwpcb-show-panel');
                $('.smwpcb_chat_input_field').removeClass('smwpcb-hide-panel');

            }

        }

        function smwpcb_hide_widget_trigger() {
            if (!$('.smwpcb_static_chat').length) {
                $('.smwpcb_online_icon').css('display', 'block');
                $('#smwpcb_chat_layout_screen').css('display', 'block');
                $('.smwpcb_chat_layout').addClass('smwpcb-hide-panel');
                $('.smwpcb_chat_layout').removeClass('smwpcb-show-panel');
                $('.smwpcb_chat_input_field').addClass('smwpcb-hide-panel');
                $('.smwpcb_chat_input_field').removeClass('smwpcb-show-panel');
            }
            if (($('#wpadminbar').length) && ($(window).width() < 768)) {
                $('.smwpcb_chat_layout').css('height', (100 - (4600 / $(window).height())) + '%');
            }
        }

    });
});